<?php
/**
* @package		Blog Calendar
* @author		Juan Padial, based on previous version of Justo Gonzalez
* @license		GNU/GPL
*/


	// no direct access

	// Include the syndicate functions only once
	require_once (dirname(__FILE__).DS.'helper.php');

	$ajax= JRequest::getInt('ajaxCalMod',0);
	$ajaxmod= JRequest::getInt('ajaxmodid',0);	
	
	if(!$params->get('cal_start_date')){
		$year	= JRequest::getVar('year',date('Y'));    /*if there is no date requested, use the current month*/
		$month	= JRequest::getVar('month',date('m'));
		$day	= $ajax? '' : JRequest::getVar('day');
	}
	else{
		
		$startDate= new JDate($params->get('cal_start_date'));		
		$year	= JRequest::getVar('year', $startDate->toFormat('%Y'));
		$month	= JRequest::getVar('month', $startDate->toFormat('%m'));
		$day	= $ajax? '' : JRequest::getVar('day', $startDate->toFormat('%d'));		
	}
	$helper = new modBlogCalendarHelper;
	$doc = JFactory::getDocument();
	
	if($ajax) {
		$calendar = $helper->showCal($params,$year,$month,$day,$ajax,$module->id); 
	} else {
	       if($params->get('use_article_date','no') == 'yes') {
		if(JRequest::getVar('option')=='com_content' && JRequest::getVar('view')=='article')
			list($year,$month,$day)=modBlogCalendarHelper::getDate_byId(JRequest::getVar('id'));
		}
                $livesite = JURI::base();
		if($params->get('show_what') == '1') {/*a list*/
		        $doc->addScript( $livesite.'modules/mod_blog_calendar/js/blog_list.js' );
			list($dropdown,$articleCounter) = $helper->showDropDown($params,$year,$month,$day,$ajax);		
		} else {
		        $doc->addScript( $livesite.'modules/mod_blog_calendar/js/blog_calendar.js' );
			$calendar = $helper->showCal($params,$year,$month,$day,$ajax,$module->id);;
		}
		JHTML::_('behavior.framework');
		$doc->addScriptDeclaration('var month=' . $month . '; var year=' . $year . '; var calendar_baseurl=\''. JURI::base() . '\';');
                JHTML::stylesheet('style.css', JUri::base().'modules/mod_blog_calendar/tmpl/');
	}
	
require(JModuleHelper::getLayoutPath('mod_blog_calendar'));

?>